// Hey ! emacs, it is an -*- objective-c -*- file

/*

    Webster Access, a program to use NeXT online Webster dictionary.
    Copyright (C) 1994 Benoit Grange, ben@fizz.fdn.org

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#import <appkit/appkit.h>
#import <store/IXStoreFile.h>
#import <btree/IXBTree.h>
#import <btree/IXBTreeCursor.h>

#import "WebsterExceptions.h"
#import "WebsterVolume.h"

@interface WebsterWord:Object
{
  const char*		word;			// The word (copy of)
  WebsterVolume*	comesFrom;		// Volume
  websterKey*		keys;			// The keys in the EntriesBtree of the volume
  int			numberOfKeys;
  void**		definitions;		// Decoded definitions, still need to be translated
  int*			defsLengths;
}

// Internal
- initForWord: (const char*) word fromVolume: (WebsterVolume*) volume andKeys: (websterKey *)keys number: (int)number;

// Name of the word
- (const char*)word;

// How many definition items exist for this word.
- (int) numberOfDefinitions;

// Get the definition as...
// You are in charge of freeing the resulting text.
- outputDefinitionAs: (const char*) mode result: (char **) where length: (int*) length;

// Get the definition as...
// You are in charge of freeing the resulting text.
- outputDefinitionAs: (const char*) mode forDefNumber: (int) defN result: (char **) where length: (int*) length;

@end
